var Comet = Comet || {};

Comet.DropdownMenu = function() {
    'use strict';
    var triggerMenuVisibleClass = "comet-dropdown-trigger--menu-visible",
        dropdownTriggerClass = "js-comet-dropdown-trigger";

    function isDropdownTrigger(target) {
        return $(target).hasClass(dropdownTriggerClass) || $(target).closest("." + dropdownTriggerClass).length > 0;
    };

    function setAllTriggersInactive() {
        $("." + triggerMenuVisibleClass).removeClass(triggerMenuVisibleClass + " comet-button--hover");
    }

    function toggleDropdownMenu($dropdownTrigger) {
        var $dropdown = $("#" + $dropdownTrigger.attr("data-comet-popover"));
        setAllTriggersInactive();

        if ($dropdown.hasClass("visible")) {
            $dropdownTrigger.removeClass(triggerMenuVisibleClass);
            $dropdown.trigger("hide");

            if ($dropdownTrigger.hasClass("comet-button")) {
                $dropdownTrigger.removeClass("comet-button--hover");
            }
        } else {
            $dropdownTrigger.addClass(triggerMenuVisibleClass);
            $dropdown.trigger("show", { "el": $dropdownTrigger[0] });

            if ($dropdownTrigger.hasClass("comet-button")) {
                $dropdownTrigger.addClass("comet-button--hover");
            }
        }
    };

    function setEventListeners($dropdownTrigger) {
        $dropdownTrigger.on("click", function(e){
            e.preventDefault();
            toggleDropdownMenu($(this));
        });

        $(document).on("click touchend", function(event) {
            if (!isDropdownTrigger(event.target)) {
                setAllTriggersInactive();
            }
        });
    };

    var initialize = function initialize() {
        $("." + dropdownTriggerClass).each(function(){
            setEventListeners($(this));
        });
    };

    var publicVars = {
        'initialize': initialize
    };

    return publicVars;
}();

$(document).ready(function(){
    'use strict';
    Comet.DropdownMenu.initialize();
});
